<?php

require_once('/usr/fallback/beroConf.php');

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'ProvisioningSetConfiguration';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		if (!isset($this->_get['Mode']) || !isset($this->_get['Url'])) {
			$this->_execResultString = 'error:invalid_parameters';
			$this->_execResult = false;
			return($this->_execResult);
		}

		if (!in_array($this->_get['Mode'], array('off', 'once', 'always'))) {
			$this->_execResultString = 'error:parameter_mode_invalid';
			$this->_execResult = false;
			return($this->_execResult);
		}

		// get protocol server and path
		preg_match('/(?P<protocol>^http|^tftp):\/\/(?P<server>[0-9a-zA-z\.]*)(?P<port>:[0-9]*|)(?P<path>\/.*)/', $this->_get['Url'], $matches);

		if (!in_array($matches['protocol'], array('http', 'tftp'))) {
			$this->_execResultString = 'error:invalid_protocol_specified';
			$this->_execResult = false;
			return($this->_execResult);
		}

		$bc = new beroConf('root');
		$bc->set('root', 'provisioning-option', $matches['protocol']);
		$bc->set('root', $matches['protocol'] .'-host', $matches['server'] . $matches['port']);
		$bc->set('root', $matches['protocol'] . '-url', $matches['path']);
		$bc->set('root', 'use-boot-prov', in_array($this->_get['Mode'], array('once', 'always')) ? 'yes' : 'no');

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
